macroScript BGSwitcher 
category:"BGSwitcher" 
tooltip:"Background Switcher"
Icon:#("bgSwitcher",30)


-- Background switcher v.1 	
-- Date:05-Sep-10 (tested on 3dMax 2011)
-- Author: Igor Grinchesku
-- website: www.grinchesku.co.cc
-- E-mail:arahnoiddesign@gmail.com
-------------------------------------------------------------------
-- This script allow you to change viewport background on the fly
-- what make you viewport to look like Maya, Modo, ZBrush ect.
-- in this version are included 8 gradient style backgrounds 
-- Maya,Mudbox (2 styles),Zbrush,MARI(2 styles),Modo and 3DCoat
-- also are included 8 flat viewport colors 
-- first two are from ame_lidght and ame_dark color schemes of 3dMax
--------------------------------------------------------------------

(
	
	rollout BGSwitcher "BGSwitcher" width:136 height:176
	(
		
		button onoffBtn "ON/OFF" pos:[8,8] width:120 height:16
		
		--first 2 rows of buttons
		button background1 "" pos:[8,32] width:26 height:26  --maya 2011
  		button background2 "" pos:[40,32] width:26 height:26 --mudbox 2011
		button background3 "" pos:[72,32] width:26 height:26 --mudbox blue
		button background4 "" pos:[104,32] width:26 height:26 --zbrush
		button background5 "" pos:[8,64] width:26 height:26 --mari blue
		button background6 "" pos:[40,64] width:26 height:26 --mari dark
		button background7 "" pos:[72,64] width:26 height:26 --modo
		button background8 "" pos:[104,64] width:26 height:26 --3d Coat
		-- Solid colors
		button background9 "" pos:[8,104] width:26 height:26
		button background10 "" pos:[40,104] width:26 height:26
		button background11 "" pos:[72,104] width:26 height:26
		button background12 "" pos:[104,104] width:26 height:26
		button background13 "" pos:[8,136] width:26 height:26
		button background14 "" pos:[40,136] width:26 height:26
		button background15 "" pos:[72,136] width:26 height:26
		button background16 "" pos:[104,136] width:26 height:26
		--Here is area of buttons what should have images
		local theButtons = #(background1, background2, background3, background4, background5, background6, background7, background8, background9, background10, background11, background12, background13, background14, background15, background16)
		
		--function for automatic inserting button images
		fn updateButtons =
			(
				for i = 1 to theButtons.count do
				(					
						theButtons[i].images = #(
						"bgSwitcher_24i.bmp", 
						"bgSwitcher_24a.bmp", 
						30, --here show haw manny buttons you have in icons file bgSwitcher_24.bmp
						i, i, i, i, true
						)
				)
			)
			
		--put buttons images in places
		on BGSwitcher open do
			updateButtons()
-----------------------------------------------------------------------
		fn setNewBgImage imgName =
			(
				bitmapPath = "C:\Program Files\Autodesk\3ds Max 2011\Scripts\BGSwitcher\\" + imgName +".png"
				bgNewImage = openBitmap bitmapPath
					setAsBackground bgNewImage
					viewport.DispBkgImage = true
					completeRedraw()
			)
-----------------------------------------------------------------------
		-- turn on/off background image button
		on onoffBtn pressed do
			(
				if (viewport.DispBkgImage == false) then
				(
					viewport.DispBkgImage = true
					completeRedraw()
				)
				else
				(
					viewport.DispBkgImage =false
					completeRedraw()
				)

			)--end of turn on/off background image
			
----------------------------------------------------------------------
		
		on background1 pressed do
		(
			setNewBgImage "Maya2011"
		)--end of maya button
		
		on background2 pressed do
		(
			setNewBgImage "Mudbox2011"
		)--edn of 2 button
		
		on background3 pressed do
		(
			setNewBgImage"Mudbox"
		)--edn of Mudbox blue button
		
		on background4 pressed do
		(
			setNewBgImage "ZBrush"
		)--edn of ZBrush button
		
		on background5 pressed do
		(
			setNewBgImage "Mari_Blue"
		)--edn of Mari Blue button
		
		on background6 pressed do
		(
			setNewBgImage "Mari_Dark"
		)--edn of Mari Dark button
		
		on background7 pressed do
		(
			setNewBgImage "Modo"
		)--edn of Modo button
		
		on background8 pressed do
		(
			setNewBgImage "3D_Coat"
		)--edn of 3d Coat button

		--------------------------Solid colors----------------------------
		--Set solid coor of backgroun in RGB format and transfor it to point4 format
		fn rgbColor r g b = (
			pointColor = (color r g b) as Point4
			SetUIColor 41 pointColor
			viewport.DispBkgImage = false
			completeRedraw()
			)
			
			on background9 pressed do
		(
			rgbColor 147 147 147
		)--edn of ame light color button
		
		on background10 pressed do
		(
			rgbColor 76 76 76
		)--edn of ame darc button*/
		
		on background11 pressed do
		(
			rgbColor 58 89 127	
		)--edn of blue button*/
		
		on background12 pressed do
		(
			rgbColor 137 181 120
		)--edn of green button*/
		
		on background13 pressed do
		(
			rgbColor 192 220 255
		)--edn of light blue button*/
		
		on background14 pressed do
		(
			rgbColor 185 228 172
		)--edn of light gren button*/
		
		on background15 pressed do
		(
			rgbColor 255 255 255
		)--edn of white button*/
		on background16 pressed do
		(
			rgbColor 0 0 0
		)--edn of black button*/
	)
	createDialog BGSwitcher 136 176

)
